diff --git a/src/target/adiv5.c b/src/target/adiv5.c
index a45bb1d870..7a6f28d7ab 100644
--- a/src/target/adiv5.c
+++ b/src/target/adiv5.c
@@ -416,6 +416,8 @@ static void adiv5_component_probe(ADIv5_AP_t *ap, uint32_t addr, int recursion,
 				return; /* Halting failed! */
 			/* CPU now halted, read cidr again. */
 			cidr = adiv5_ap_read_id(ap, addr + CIDR0_OFFSET);
+			if ((cidr & ~CID_CLASS_MASK) != CID_PREAMBLE)
+				return;
 		}
 	}
 #if defined(ENABLE_DEBUG)
